Package com.smartgwt.client.widgets.grid

# Class Shuttle

java.lang.Object
com.google.gwt.user.client.ui.UIObject
com.google.gwt.user.client.ui.Widget
com.smartgwt.client.widgets.BaseWidget
com.smartgwt.client.widgets.Canvas
com.smartgwt.client.widgets.layout.Layout
com.smartgwt.client.widgets.grid.Shuttle

All Implemented Interfaces:
  `HasAttachHandlers`, `HasHandlers`, `EventListener`, `HasVisibility`, `IsWidget`, `LogicalStructure`, `HasClearHandlers`, `HasClickHandlers`, `HasDoubleClickHandlers`, `HasDragMoveHandlers`, `HasDragRepositionMoveHandlers`, `HasDragRepositionStartHandlers`, `HasDragRepositionStopHandlers`, `HasDragResizeMoveHandlers`, `HasDragResizeStartHandlers`, `HasDragResizeStopHandlers`, `HasDragStartHandlers`, `HasDragStopHandlers`, `HasDropHandlers`, `HasDropMoveHandlers`, `HasDropOutHandlers`, `HasDropOverHandlers`, `HasFocusChangedHandlers`, `HasHoverHandlers`, `HasHoverHiddenHandlers`, `HasKeyDownHandlers`, `HasKeyPressHandlers`, `HasMouseDownHandlers`, `HasMouseMoveHandlers`, `HasMouseOutHandlers`, `HasMouseOverHandlers`, `HasMouseStillDownHandlers`, `HasMouseUpHandlers`, `HasMouseWheelHandlers`, `HasMovedHandlers`, `HasParentMovedHandlers`, `HasResizedHandlers`, `HasRightMouseDownHandlers`, `HasRuleContextChangedHandlers`, `HasScrolledHandlers`, `HasShowContextMenuHandlers`, `HasVisibilityChangedHandlers`, `HasMembersChangedHandlers`

public class Shuttle extends Layout
Shuttle-style selection component allowing uses to select records by moving them from a set of source records to a set of target records

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from class com.google.gwt.user.client.ui.UIObject

  `UIObject.DebugIdImpl, UIObject.DebugIdImplEnabled`

- ## Field Summary

  ### Fields inherited from class com.smartgwt.client.widgets.BaseWidget

  `config, configOnly, factoryCreated, factoryProperties, id, nativeObject, scClassName`

  ### Fields inherited from class com.google.gwt.user.client.ui.UIObject

  `DEBUG_ID_PREFIX`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `Shuttle()`
  `Shuttle(JavaScriptObject jsObj)`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static void`
  `changeAutoChildDefaults(String autoChildName, Canvas defaults)`
  Changes the defaults for Canvas AutoChildren named `autoChildName`.
  `static void`
  `changeAutoChildDefaults(String autoChildName, FormItem defaults)`
  Changes the defaults for FormItem AutoChildren named `autoChildName`.
  `void`
  `clearSelection()`
  Deselect all currently selected records
  `void`
  `clearSelection(boolean fireSelectionChanged)`
  Deselect all currently selected records
  `protected JavaScriptObject`
  `create()`
  `void`
  `deselectRecords(ListGridRecord[] records)`
  Programmatically deselect a set of records that are currently selected and displayed in the target grid.
  `void`
  `deselectRecords(ListGridRecord[] records, boolean fireSelectionChanged)`
  Programmatically deselect a set of records that are currently selected and displayed in the target grid.
  `VLayout`
  `getControlBar()`
  VLayout autoChild holding the `selectAllButton`, `selectButton`, `deselectButton` and `deselectAllButton`
  `DataSource`
  `getDataSource()`
  DataSource for this shuttle's data set.
  `ImgButton`
  `getDeselectAllButton()`
  ImgButton for deselecting the full set of selected data in the shuttle.
  `Integer`
  `getDeselectAllButtonHeight()`
  Height for the `deselectAllButton`
  `String`
  `getDeselectAllButtonIcon()`
  Icon for the `deselectAllButton`
  `Integer`
  `getDeselectAllButtonWidth()`
  Width for the `deselectAllButton`
  `ImgButton`
  `getDeselectButton()`
  ImgButton for deselecting a single record
  `Integer`
  `getDeselectButtonHeight()`
  Height for the `deselectButton`
  `String`
  `getDeselectButtonIcon()`
  Icon for the `deselectButton`
  `Integer`
  `getDeselectButtonWidth()`
  Width for the `deselectButton`
  `String`
  `getFetchOperation()`
  `OperationId` for fetching records from the shuttle's `DataSource`.
  `ListGridField[]`
  `getFields()`
  Fields for the `sourceGrid` and `targetGrid`.
  `DSRequest`
  `getFilterContext()`
  DSRequest configuration for retrieving records from this shuttle's dataSource.
  `Criteria`
  `getImplicitCriteria()`
  Implicit criteria for retrieving records from this shuttle's dataSource.
  `String`
  `getIncompleteDataWarning()`
  Warning to display when the user attempts to `select all` records from a `partially loaded` data set.
  `SortSpecifier[]`
  `getInitialSort()`
  `Initial sort specifiers` for this item's list of options.
  `String`
  `getLoadingPlaceholderAttribute()`
  This attribute will be set to true for any loading placeholder records returned by `getSelectedRecords()`
  `LogicalStructureObject`
  `getLogicalStructure()`
  Getter implementing the `LogicalStructure` interface, which supports Eclipse's logical structure debugging facility.
  `static Shuttle`
  `getOrCreateRef(JavaScriptObject jsObj)`
  `ImgButton`
  `getSelectAllButton()`
  ImgButton for selecting the full set of data in the shuttle.
  `Integer`
  `getSelectAllButtonHeight()`
  Height for the `selectAllButton`
  `String`
  `getSelectAllButtonIcon()`
  Icon for the `selectAllButton`
  `Integer`
  `getSelectAllButtonWidth()`
  Width for the `selectAllButton`
  `ImgButton`
  `getSelectButton()`
  ImgButton for selecting a single record
  `Integer`
  `getSelectButtonHeight()`
  Height for the `selectButton`
  `String`
  `getSelectButtonIcon()`
  Icon for the `selectButton`
  `Integer`
  `getSelectButtonWidth()`
  Width for the `selectButton`
  `ListGridRecord`
  `getSelectedRecords()`
  A shuttle may be initialized with a set of selected records via `setSelectedRecords()` before the shuttle has been created.
  `String[]`
  `getSelectedValues()`
  Initial selected values for the shuttle.
  `int[]`
  `getSelectedValuesAsIntArray()`
  Initial selected values for the shuttle.
  `SortDirection`
  `getSortDirection()`
  `Sort direction` for this item's list of options.
  `String`
  `getSortField()`
  `Sort field` for this item's list of options.
  `Integer`
  `getSortFieldAsInt()`
  `Sort field` for this item's list of options.
  `String[]`
  `getSortFieldAsStringArray()`
  `Sort field` for this item's list of options.
  `ListGrid`
  `getSourceGrid()`
  List grid containing the (unselected) set of records.
  `String`
  `getSourceGridTitle()`
  Title for the source grid, shown as a `Canvas.groupTitle`
  `ListGrid`
  `getTargetGrid()`
  List grid containing the selected set of records.
  `String`
  `getTargetGridTitle()`
  Title for the target grid, shown as a `Canvas.groupTitle`
  `TextMatchStyle`
  `getTextMatchStyle()`
  TextMatchStyle for retrieving records from this shuttle's dataSource.
  `String`
  `getValueField()`
  This field is expected to be unique for records within the shuttle's data set.
  `String`
  `getValueFieldName()`
  Returns the `valueField` for this shuttle
  `void`
  `selectionUpdated()`
  Notification method fired when records are selected or unselected in this shuttle.
  `void`
  `selectRecords(ListGridRecord[] records)`
  Programmatically select a set of records from this shuttle's dataSource.
  `void`
  `selectRecords(ListGridRecord[] records, boolean fireSelectionChanged)`
  Programmatically select a set of records from this shuttle's dataSource.
  `Shuttle`
  `setData(Record... data)`
  List of options for this shuttle.
  `Shuttle`
  `setDataSource(DataSource dataSource)`
  DataSource for this shuttle's data set.
  `static void`
  `setDefaultProperties(Shuttle shuttleProperties)`
  Class level method to set the default properties of this class.
  `Shuttle`
  `setDeselectAllButtonHeight(Integer deselectAllButtonHeight)`
  Height for the `deselectAllButton`
  `Shuttle`
  `setDeselectAllButtonIcon(String deselectAllButtonIcon)`
  Icon for the `deselectAllButton`
  `Shuttle`
  `setDeselectAllButtonWidth(Integer deselectAllButtonWidth)`
  Width for the `deselectAllButton`
  `Shuttle`
  `setDeselectButtonHeight(Integer deselectButtonHeight)`
  Height for the `deselectButton`
  `Shuttle`
  `setDeselectButtonIcon(String deselectButtonIcon)`
  Icon for the `deselectButton`
  `Shuttle`
  `setDeselectButtonWidth(Integer deselectButtonWidth)`
  Width for the `deselectButton`
  `Shuttle`
  `setFetchOperation(String fetchOperation)`
  `OperationId` for fetching records from the shuttle's `DataSource`.
  `Shuttle`
  `setFields(ListGridField... fields)`
  Fields for the `sourceGrid` and `targetGrid`.
  `Shuttle`
  `setFilterContext(DSRequest filterContext)`
  DSRequest configuration for retrieving records from this shuttle's dataSource.
  `Shuttle`
  `setImplicitCriteria(Criteria implicitCriteria)`
  Implicit criteria for retrieving records from this shuttle's dataSource.
  `Shuttle`
  `setIncompleteDataWarning(String incompleteDataWarning)`
  Warning to display when the user attempts to `select all` records from a `partially loaded` data set.
  `Shuttle`
  `setInitialSort(SortSpecifier... initialSort)`
  `Initial sort specifiers` for this item's list of options.
  `Shuttle`
  `setLoadingPlaceholderAttribute(String loadingPlaceholderAttribute)`
  This attribute will be set to true for any loading placeholder records returned by `getSelectedRecords()`
  `LogicalStructureObject`
  `setLogicalStructure(ShuttleLogicalStructure s)`
  Setter implementing the `LogicalStructure` interface, which supports Eclipse's logical structure debugging facility.
  `Shuttle`
  `setSelectAllButtonHeight(Integer selectAllButtonHeight)`
  Height for the `selectAllButton`
  `Shuttle`
  `setSelectAllButtonIcon(String selectAllButtonIcon)`
  Icon for the `selectAllButton`
  `Shuttle`
  `setSelectAllButtonWidth(Integer selectAllButtonWidth)`
  Width for the `selectAllButton`
  `Shuttle`
  `setSelectButtonHeight(Integer selectButtonHeight)`
  Height for the `selectButton`
  `Shuttle`
  `setSelectButtonIcon(String selectButtonIcon)`
  Icon for the `selectButton`
  `Shuttle`
  `setSelectButtonWidth(Integer selectButtonWidth)`
  Width for the `selectButton`
  `void`
  `setSelectedByValue(int[] value, Boolean selected)`
  Method to add or remove records from the current selection where the `valueField` matches the values passed in.
  `void`
  `setSelectedByValue(String[] value, Boolean selected)`
  Method to add or remove records from the current selection where the `valueField` matches the values passed in.
  `Shuttle`
  `setSelectedRecords(ListGridRecord selectedRecords)`
  A shuttle may be initialized with a set of selected records via `setSelectedRecords()` before the shuttle has been created.
  `Shuttle`
  `setSelectedValues(int... selectedValues)`
  Initial selected values for the shuttle.
  `Shuttle`
  `setSelectedValues(String... selectedValues)`
  Initial selected values for the shuttle.
  `Shuttle`
  `setSortDirection(SortDirection sortDirection)`
  `Sort direction` for this item's list of options.
  `Shuttle`
  `setSortField(Integer sortField)`
  `Sort field` for this item's list of options.
  `Shuttle`
  `setSortField(String sortField)`
  `Sort field` for this item's list of options.
  `Shuttle`
  `setSortField(String... sortField)`
  `Sort field` for this item's list of options.
  `Shuttle`
  `setSourceGridTitle(String sourceGridTitle)`
  Title for the source grid, shown as a `Canvas.groupTitle`
  `Shuttle`
  `setTargetGridTitle(String targetGridTitle)`
  Title for the target grid, shown as a `Canvas.groupTitle`
  `Shuttle`
  `setTextMatchStyle(TextMatchStyle textMatchStyle)`
  TextMatchStyle for retrieving records from this shuttle's dataSource.
  `Shuttle`
  `setValueField(String valueField)`
  This field is expected to be unique for records within the shuttle's data set.
  `boolean`
  `valuesFetchComplete()`
  Notification method fired when a fetch to retrieve records for an array of values passed to `setSelectedByValue()` is complete.
  `boolean`
  `valuesFetchInProgress()`
  Returns true if this shuttle is currently fetching record(s) associated with values passed to `setSelectedByValue()`
  `boolean`
  `valuesFetchInProgress(Object value)`
  Returns true if this shuttle is currently fetching record(s) associated with values passed to `setSelectedByValue()`

  ### Methods inherited from class com.smartgwt.client.widgets.layout.Layout

  `addMember, addMember, addMember, addMember, addMemberPostCreate, addMemberPostCreate, addMemberPreCreate, addMemberPreCreate, addMembers, addMembers, addMembersChangedHandler, getAnimateMembers, getAnimateMemberTime, getCanDropComponents, getChildTabPosition, getDefaultResizeBars, getDropComponent, getDropLine, getDropLineThickness, getDropPosition, getEditProxyConstructor, getEnforcePolicy, getHPolicy, getLayoutBottomMargin, getLayoutEndMargin, getLayoutLeftMargin, getLayoutMargin, getLayoutRightMargin, getLayoutStartMargin, getLayoutTopMargin, getLeaveScrollbarGap, getLocateMembersBy, getLocateMembersType, getManagePercentBreadth, getMember, getMember, getMemberDefaultBreadth, getMemberNumber, getMemberNumber, getMemberOverlap, getMembers, getMembersAsStringArray, getMembersLength, getMembersMargin, getMinMemberLength, getMinMemberSize, getOverflow, getPaddingAsLayoutMargin, getResizeBar, getResizeBarClass, getResizeBarSize, getReverseOrder, getShowDragPlaceHolder, getShowDropLines, getStackZIndex, getVertical, getVPolicy, hasMember, hideDropLine, hideMember, hideMember, layoutIsDirty, onInit, onInit_Layout, reflow, reflow, reflowNow, removeMember, removeMembers, removeMembers, reorderMember, reorderMembers, replaceMember, revealChild, revealChild, setAlign, setAlign, setAnimateMembers, setAnimateMemberTime, setCanDropComponents, setDefaultLayoutAlign, setDefaultLayoutAlign, setDefaultProperties, setDefaultResizeBars, setDropLineProperties, setDropLineThickness, setEditProxyConstructor, setEnforcePolicy, setHPolicy, setLayoutBottomMargin, setLayoutEndMargin, setLayoutLeftMargin, setLayoutMargin, setLayoutRightMargin, setLayoutStartMargin, setLayoutTopMargin, setLeaveScrollbarGap, setLocateMembersBy, setLocateMembersType, setLogicalStructure, setManagePercentBreadth, setMemberOverlap, setMembers, setMembers, setMembersMargin, setMinBreadthMember, setMinBreadthMember, setMinBreadthMember, setMinMemberLength, setMinMemberSize, setOverflow, setPaddingAsLayoutMargin, setPlaceHolderDefaults, setPlaceHolderProperties, setResizeBarClass, setResizeBarSize, setReverseOrder, setShowDragPlaceHolder, setShowDropLines, setStackZIndex, setVertical, setVisibleMember, setVPolicy, showMember, showMember`

  ### Methods inherited from class com.smartgwt.client.widgets.Canvas

  `addChild, addChild, addChild, addChild, addChild, addClearHandler, addClickHandler, addDoubleClickHandler, addDragMoveHandler, addDragRepositionMoveHandler, addDragRepositionStartHandler, addDragRepositionStopHandler, addDragResizeMoveHandler, addDragResizeStartHandler, addDragResizeStopHandler, addDragStartHandler, addDragStopHandler, addDropHandler, addDropMoveHandler, addDropOutHandler, addDropOverHandler, addFocusChangedHandler, addHoverHandler, addHoverHiddenHandler, addKeyDownHandler, addKeyPressHandler, addMouseDownHandler, addMouseMoveHandler, addMouseOutHandler, addMouseOverHandler, addMouseStillDownHandler, addMouseUpHandler, addMouseWheelHandler, addMovedHandler, addParentMovedHandler, addPeer, addPeer, addPeer, addPeer, addResizedHandler, addRightMouseDownHandler, addRuleContextChangedHandler, addScrolledHandler, addShowContextMenuHandler, addSnapAlignCandidate, addStyleName, addVisibilityChangedHandler, adjustForContent, animateFade, animateFade, animateFade, animateFade, animateFade, animateFade, animateFade, animateFade, animateHide, animateHide, animateHide, animateHide, animateHide, animateHide, animateHide, animateMove, animateMove, animateMove, animateMove, animateRect, animateRect, animateRect, animateRect, animateResize, animateResize, animateResize, animateResize, animateScroll, animateScroll, animateScroll, animateScroll, animateScroll, animateScroll, animateShow, animateShow, animateShow, animateShow, animateShow, animateShow, animateShow, asSGWTComponent, blur, bringToFront, clear, clearExplicitTabIndex, clickMaskUp, clickMaskUp, contains, contains, containsEvent, containsEventTarget, containsFocus, containsPoint, containsPoint, contentsComponentConnected, dataContextChanged, dataContextCriteriaChanged, deparent, depeer, disable, doValueDictation, doVoiceCommand, enable, encloses, endBatchCreation, focus, focusAfterGroup, focusAtEnd, focusInNextTabElement, focusInPreviousTabElement, getAbsoluteLeft, getAbsoluteTop, getAccessKey, getAdaptiveHeightPriority, getAdaptiveWidthPriority, getAllCanvases, getAllCanvases, getAllCanvases, getAlwaysManageFocusNavigation, getAlwaysShowScrollbars, getAnimateAcceleration, getAnimateFadeTime, getAnimateHideAcceleration, getAnimateHideEffect, getAnimateHideTime, getAnimateMoveAcceleration, getAnimateMoveTime, getAnimateRectAcceleration, getAnimateRectTime, getAnimateResizeAcceleration, getAnimateResizeLayoutMode, getAnimateResizeTime, getAnimateScrollAcceleration, getAnimateScrollTime, getAnimateShowAcceleration, getAnimateShowEffect, getAnimateShowTime, getAnimateTime, getAppImgDir, getAriaHandleID, getAriaRole, getAriaStateDefaults, getAutoMaskComponents, getAutoParent, getAutoPopulateData, getAutoRevertStyles, getAutoShowParent, getBackgroundColor, getBackgroundImage, getBackgroundPosition, getBackgroundRepeat, getBorder, getBorderRadius, getBottom, getById, getByJSObject, getByLocalId, getCanAcceptDrop, getCanAdaptHeight, getCanAdaptWidth, getCanDrag, getCanDragReposition, getCanDragResize, getCanDragScroll, getCanDrop, getCanDropBefore, getCanDropContent, getCanDropFiles, getCanFocus, getCanHover, getCanSelectText, getCanvasAutoChild, getCanvasItem, getChildren, getChildrenAsStringArray, getChildrenResizeSnapAlign, getChildrenSnapAlign, getChildrenSnapCenterAlign, getChildrenSnapEdgeAlign, getChildrenSnapResizeToGrid, getChildrenSnapToGrid, getClassName, getComponentMask, getComponentMaskDefaults, getContentElement, getContents, getContentsComponentDefaults, getContextMenu, getControlHeight, getCorrectZoomOverflow, getCursor, getDataContext, getDataContextCriteria, getDataContextCriteria, getDataPath, getDefaultHeight, getDefaultWidth, getDeferActionConversion, getDefiningProperty, getDefiningPropertyName, getDefiningPropertyNameOptions, getDestroyed, getDestroying, getDisabled, getDisabledCursor, getDisableTouchScrollingForDrag, getDoubleClickDelay, getDragAppearance, getDragIntersectStyle, getDragMaskType, getDragMaxHeight, getDragMaxWidth, getDragMinHeight, getDragMinWidth, getDragOpacity, getDragRepositionAppearance, getDragRepositionCursor, getDragResizeAppearance, getDragScrollDelay, getDragStartDistance, getDragTarget, getDragTargetAsString, getDragType, getDropTarget, getDropTargetAsString, getDropTypes, getDropTypesAsString, getDynamicContents, getEdgeBackgroundColor, getEdgeCenterBackgroundColor, getEdgeImage, getEdgeMarginSize, getEdgeOffset, getEdgeOpacity, getEdgeShowCenter, getEdgeSize, getEditNode, getEditProxy, getElement, getElement, getEnableWhen, getEndLine, getEventEdge, getEventEdge, getEvents, getExtraSpace, getFacetId, getFloatingScrollbars, getFormItemAutoChild, getForwardSVGeventsToObject, getFullDataPath, getGroupBorderCSS, getGroupLabelBackgroundColor, getGroupLabelStyleName, getGroupPadding, getGroupTitle, getHeight, getHeightAsString, getHideUsingDisplayNone, getHoverAlign, getHoverAutoDestroy, getHoverAutoFitMaxWidth, getHoverAutoFitMaxWidthAsString, getHoverAutoFitWidth, getHoverComponent, getHoverDelay, getHoverFocusKey, getHoverHeight, getHoverHTML, getHoverMoveWithMouse, getHoverOpacity, getHoverPersist, getHoverScreen, getHoverStyle, getHoverVAlign, getHoverWidth, getHoverWrap, getHSnapPosition, getHSnapPosition, getHtmlElement, getHtmlElementAsString, getHtmlPosition, getImage, getImgURL, getImgURL, getInnerContentHeight, getInnerContentWidth, getInnerHeight, getInnerWidth, getIsGroup, getIsPrinting, getIsRuleScope, getIsSnapAlignCandidate, getKeepInParentRect, getLayoutAlign, getLeaveGroupLabelSpace, getLeavePageSpace, getLeft, getLeftAsString, getLocalId, getLocateByIDOnly, getLocateChildrenBy, getLocateChildrenType, getLocatePeersBy, getLocatePeersType, getLocatorName, getMargin, getMasterCanvas, getMasterElement, getMatchElement, getMatchElementHeight, getMatchElementWidth, getMaxHeight, getMaxWidth, getMaxZoomOverflowError, getMenuConstructor, getMinHeight, getMinNonEdgeSize, getMinWidth, getMomentumScrollMinSpeed, getMouseStillDownDelay, getMouseStillDownInitialDelay, getName, getNativeAutoHideScrollbars, getNextZIndex, getNoDoubleClicks, getNoDropCursor, getOffsetHeight, getOffsetWidth, getOffsetX, getOffsetY, getOpacity, getOuterElement, getPadding, getPageBottom, getPageLeft, getPageRect, getPageRight, getPageTop, getPaletteDefaults, getPanelContainer, getParentCanvas, getParentCanvasAsString, getParentElement, getParentElementAsString, getPeers, getPendingMarkerStyle, getPendingMarkerVisible, getPercentBox, getPercentSource, getPersistentMatchElement, getPointerSettings, getPointerTarget, getPointerTargetAsString, getPosition, getPrefix, getPrintChildrenAbsolutelyPositioned, getPrintHTML, getPrintHTML, getPrintStyleName, getPrompt, getProportionalResizeModifiers, getProportionalResizing, getReceiveScrollbarEvents, getRect, getRedrawOnResize, getResizeBarTarget, getResizeFrom, getRight, getRuleContext, getRuleContext, getRuleScope, getScrollbarSize, getScrollBottom, getScrollHeight, getScrollLeft, getScrollRight, getScrollTop, getScrollWidth, getShadowColor, getShadowDepth, getShadowHOffset, getShadowImage, getShadowOffset, getShadowSoftness, getShadowSpread, getShadowVOffset, getShareCriteria, getShouldPrint, getShowCustomScrollbars, getShowDragShadow, getShowEdges, getShowFocusOutline, getShowHover, getShowHoverComponents, getShowPointer, getShowResizeBar, getShowShadow, getShowSnapGrid, getShrinkElementOnHide, getSingleDiv, getSizeMayChangeOnRedraw, getSkinImgDir, getSnapAlignCandidates, getSnapAlignCenterLineStyle, getSnapAlignEdgeLineStyle, getSnapAxis, getSnapEdge, getSnapGridLineProperties, getSnapGridStyle, getSnapHDirection, getSnapHGap, getSnapOffsetLeft, getSnapOffsetTop, getSnapOnDrop, getSnapPosition, getSnapPosition, getSnapResizeToAlign, getSnapResizeToGrid, getSnapTo, getSnapToAlign, getSnapToCenterAlign, getSnapToEdgeAlign, getSnapToGrid, getSnapVDirection, getSnapVGap, getStartLine, getStyleName, getSuppressRedraw, getTabIndex, getTestDataContext, getTestInstance, getTitle, getTooltip, getTop, getTopAsString, getTopElement, getTopLevelComponents, getUpdateTabPositionOnDraw, getUpdateTabPositionOnReparent, getUseBackMask, getUseCSSShadow, getUseDataContextCriteria, getUseDragMask, getUseGeneratedStyles, getUseImageForSVG, getUseNativeDrag, getUseOpacityFilter, getUseTouchScrolling, getValuesManager, getValuesManagerAsString, getViewportHeight, getViewportWidth, getVisibility, getVisibleHeight, getVisibleWhen, getVisibleWidth, getVSnapPosition, getVSnapPosition, getWidth, getWidthAsString, getWorkflows, getZIndex, getZIndex, handleDataContextCriteria, handleHover, hide, hideClickMask, hideClickMask, hideComponentMask, hideComponentMask, hideContextMenu, imgHTML, imgHTML, imgHTML, initComplete, intersects, isDirty, isDisabled, isFocused, isVisible, keyUp, layoutChildren, linkHTML, linkHTML, linkHTML, linkHTML, linkHTML, linkHTML, markForDestroy, markForRedraw, markForRedraw, moveAbove, moveBelow, moveBy, moveTo, onAttach, onDetach, pageScrollDown, pageScrollUp, parentResized, placeNear, placeNear, placeNear, print, print, print, print, printComponents, provideRuleContext, provideRuleContext, redraw, redraw, registerAIService, registerFontScaledPaddingStyles, removeChild, removeChild, removePeer, removePeer, removeRuleContext, removeSnapAlignCandidate, resizeAutoChildAttributes, resizeBy, resizeControls, resizeControlsTo, resizeFonts, resizeFonts, resizeFonts, resizeFontsTo, resizeIcons, resizePadding, resizePadding, resizeTo, resizeTo, resolveContentsComponent, scrollBy, scrollByPercent, scrollTo, scrollTo, scrollTo, scrollTo, scrollTo, scrollToBottom, scrollToLeft, scrollToPercent, scrollToRight, scrollToTop, sendToBack, setAccessKey, setAdaptHeightByCustomizer, setAdaptiveHeightPriority, setAdaptiveWidthPriority, setAdaptWidthByCustomizer, setAllowExternalFilters, setAlwaysManageFocusNavigation, setAlwaysShowScrollbars, setAnimateAcceleration, setAnimateFadeTime, setAnimateHideAcceleration, setAnimateHideEffect, setAnimateHideTime, setAnimateMoveAcceleration, setAnimateMoveTime, setAnimateRectAcceleration, setAnimateRectTime, setAnimateResizeAcceleration, setAnimateResizeLayoutMode, setAnimateResizeTime, setAnimateScrollAcceleration, setAnimateScrollTime, setAnimateShowAcceleration, setAnimateShowEffect, setAnimateShowTime, setAnimateTime, setAppImgDir, setAriaRole, setAriaState, setAutoChildConstructor, setAutoChildProperties, setAutoChildProperties, setAutoChildProperties, setAutoChildProperties, setAutoChildVisibility, setAutoHeight, setAutoMaskComponents, setAutoParent, setAutoPopulateData, setAutoResizeAutoChildAttributes, setAutoResizeIcons, setAutoRevertStyles, setAutoShowParent, setAutoWidth, setBackgroundColor, setBackgroundImage, setBackgroundPosition, setBackgroundRepeat, setBorder, setBorderRadius, setBottom, setCanAcceptDrop, setCanAdaptHeight, setCanAdaptWidth, setCanDrag, setCanDragReposition, setCanDragResize, setCanDragScroll, setCanDrop, setCanDropBefore, setCanDropContent, setCanDropFiles, setCanFocus, setCanHover, setCanSelectText, setChildren, setChildrenResizeSnapAlign, setChildrenSnapAlign, setChildrenSnapCenterAlign, setChildrenSnapEdgeAlign, setChildrenSnapResizeToGrid, setChildrenSnapToGrid, setComponentMaskDefaults, setContents, setContentsComponentDefaults, setContextMenu, setCorrectZoomOverflow, setCursor, setDataContext, setDataContextCriteria, setDataContextCriteria, setDataContextCriteria, setDataContextCriteria, setDataContextCriteria, setDataContextCriteria, setDataContextCriteria, setDataContextCriteria, setDataPath, setDefaultHeight, setDefaultNativeAutoHideScrollbars, setDefaultPageSpace, setDefaultProperties, setDefaultShowCustomScrollbars, setDefaultWidth, setDeferActionConversion, setDefiningProperty, setDefiningPropertyNameOptions, setDisabled, setDisabledCursor, setDisableTouchScrollingForDrag, setDoubleClickDelay, setDragAppearance, setDragIntersectStyle, setDragMaskType, setDragMaxHeight, setDragMaxWidth, setDragMinHeight, setDragMinWidth, setDragOpacity, setDragRepositionAppearance, setDragRepositionCursor, setDragResizeAppearance, setDragScrollDelay, setDragStartDistance, setDragTarget, setDragTarget, setDragType, setDropTarget, setDropTarget, setDropTypes, setDropTypes, setDynamicContents, setEdgeBackgroundColor, setEdgeCenterBackgroundColor, setEdgeImage, setEdgeMarginSize, setEdgeOffset, setEdgeOpacity, setEdgeShowCenter, setEdgeSize, setEditMode, setEditMode, setEditMode, setElement, setEnableWhen, setEndLine, setExtraSpace, setFacetId, setFloatingScrollbars, setForwardSVGeventsToObject, setGroupBorderCSS, setGroupLabelBackgroundColor, setGroupLabelStyleName, setGroupPadding, setGroupTitle, setHeight, setHeight, setHeight, setHeight100, setHideUsingDisplayNone, setHoverAlign, setHoverAutoDestroy, setHoverAutoFitMaxWidth, setHoverAutoFitMaxWidth, setHoverAutoFitWidth, setHoverDelay, setHoverFocusKey, setHoverHeight, setHoverMoveWithMouse, setHoverOpacity, setHoverPersist, setHoverScreen, setHoverStyle, setHoverVAlign, setHoverWidth, setHoverWrap, setHtmlElement, setHtmlElement, setHtmlPosition, setImage, setImage, setInitHandler, setIsGroup, setIsRuleScope, setIsSnapAlignCandidate, setKeepInParentRect, setKeepInParentRect, setKeepInParentRect, setLayoutAlign, setLayoutAlign, setLeaveGroupLabelSpace, setLeavePageSpace, setLeft, setLeft, setLocateByIDOnly, setLocateChildrenBy, setLocateChildrenType, setLocatePeersBy, setLocatePeersType, setLocatorName, setLocatorParent, setLocatorParent, setLogicalStructure, setMargin, setMatchElement, setMatchElementHeight, setMatchElementWidth, setMaxHeight, setMaxWidth, setMaxZoomOverflowError, setMenuConstructor, setMinHeight, setMinNonEdgeSize, setMinWidth, setMomentumScrollMinSpeed, setMouseStillDownDelay, setMouseStillDownInitialDelay, setName, setNativeAutoHideScrollbars, setNeverUseFilters, setNoDoubleClicks, setNoDropCursor, setOpacity, setPadding, setPageLeft, setPageTop, setPanelContainer, setParentCanvas, setParentCanvas, setParentElement, setParentElement, setPeers, setPendingMarkerStyle, setPendingMarkerVisible, setPercentBox, setPercentSource, setPersistentMatchElement, setPointerSettings, setPointerTarget, setPosition, setPrefix, setPrintChildrenAbsolutelyPositioned, setPrintStyleName, setPrompt, setProportionalResizeModifiers, setProportionalResizing, setReceiveScrollbarEvents, setRect, setRect, setRedrawOnResize, setRelativeTabPosition, setResizeBarTarget, setResizeFrom, setResizeFrom, setRight, setRuleScope, setScrollbarConstructor, setScrollbarSize, setShadowColor, setShadowDepth, setShadowHOffset, setShadowImage, setShadowOffset, setShadowSoftness, setShadowSpread, setShadowVOffset, setShareCriteria, setShouldPrint, setShowCustomScrollbars, setShowDragShadow, setShowEdges, setShowFocusOutline, setShowHover, setShowHoverComponents, setShowPointer, setShowResizeBar, setShowShadow, setShowSnapGrid, setShrinkElementOnHide, setSingleDiv, setSizeMayChangeOnRedraw, setSkinImgDir, setSmoothFade, setSnapAlignCandidates, setSnapAlignCenterLineStyle, setSnapAlignEdgeLineStyle, setSnapAxis, setSnapEdge, setSnapGridLineProperties, setSnapGridStyle, setSnapHDirection, setSnapHGap, setSnapOffsetLeft, setSnapOffsetTop, setSnapOnDrop, setSnapResizeToAlign, setSnapResizeToGrid, setSnapTo, setSnapToAlign, setSnapToCenterAlign, setSnapToEdgeAlign, setSnapToGrid, setSnapVDirection, setSnapVGap, setStartLine, setStyleName, setSuppressRedraw, setTabIndex, setTestDataContext, setTitle, setTooltip, setTop, setTop, setUpdateTabPositionOnDraw, setUpdateTabPositionOnReparent, setUseBackMask, setUseCSSShadow, setUseDataContextCriteria, setUseDragMask, setUseGeneratedStyles, setUseImageForSVG, setUseNativeDrag, setUseOpacityFilter, setUseTouchScrolling, setValuesManager, setValuesManager, setVisibility, setVisible, setVisibleWhen, setWidth, setWidth, setWidth, setWidth100, setWorkflows, setZIndex, shouldDragScroll, show, showClickMask, showComponentMask, showComponentMask, showNextTo, showNextTo, showNextTo, showNextTo, showPendingMarker, showPrintPreview, showPrintPreview, showPrintPreview, showPrintPreview, showRecursively, startBatchCreation, startDebuggingOverflow, stopDebuggingOverflow, subtractRects, supportsValueDictation, supportsVoiceCommands, unregisterAIService, updateChildTabPosition, updateChildTabPositions, updateEditNode, updateHover, updateHover, updateShadow, updateTabPositionForDraw, visibleAtPoint, willAcceptDrop`

  ### Methods inherited from class com.smartgwt.client.widgets.BaseWidget

  `addDrawHandler, addDynamicProperty, addDynamicProperty, addDynamicProperty, addDynamicProperty, applyFactoryProperties, clearDynamicProperty, completeCreation, destroy, doAddHandler, doInit, doOnRender, draw, equals, error, errorIfNotCreated, getAttribute, getAttributeAsBoolean, getAttributeAsDate, getAttributeAsDateArray, getAttributeAsDouble, getAttributeAsElement, getAttributeAsFloat, getAttributeAsFloatArray, getAttributeAsInt, getAttributeAsIntArray, getAttributeAsJavaScriptObject, getAttributeAsMap, getAttributeAsObject, getAttributeAsRecord, getAttributeAsString, getAttributeAsStringArray, getAutoDraw, getConfig, getDOM, getHandlerCount, getID, getInnerHTML, getJsObj, getOrCreateJsObj, getRef, getScClassName, hasAutoAssignedID, hasDynamicProperty, hashCode, initNativeObject, internalSetID, internalSetID, isConfigOnly, isCreated, isDrawn, isFactoryCreated, onBind, onDestroy, onDraw, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAutoDraw, setConfig, setConfigOnly, setDefaultProperties, setDragTracker, setFactoryCreated, setID, setJavaScriptObject, setLogicalStructure, setLogicalStructure, setNullProperty, setPosition, setProperty, setProperty, setProperty, setProperty, setProperty, setProperty, setProperty, setScClassName, toString`

  ### Methods inherited from class com.google.gwt.user.client.ui.Widget

  `addAttachHandler, addBitlessDomHandler, addDomHandler, addHandler, asWidget, asWidgetOrNull, createHandlerManager, delegateEvent, doAttachChildren, doDetachChildren, fireEvent, getLayoutData, getParent, isAttached, isOrWasAttached, onBrowserEvent, onLoad, onUnload, removeFromParent, setLayoutData, sinkEvents, unsinkEvents`

  ### Methods inherited from class com.google.gwt.user.client.ui.UIObject

  `addStyleDependentName, ensureDebugId, ensureDebugId, ensureDebugId, getStyleElement, getStyleName, getStylePrimaryName, getStylePrimaryName, isVisible, onEnsureDebugId, removeStyleDependentName, removeStyleName, resolvePotentialElement, setElement, setPixelSize, setSize, setStyleDependentName, setStyleName, setStyleName, setStyleName, setStylePrimaryName, setStylePrimaryName, setVisible, sinkBitlessEvent`

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface com.google.gwt.event.shared.HasHandlers

  `fireEvent`

- ## Constructor Details

  - ### Shuttle

    public Shuttle()

  - ### Shuttle

    public Shuttle(JavaScriptObject jsObj)

- ## Method Details

  - ### getOrCreateRef

    public static Shuttle getOrCreateRef(JavaScriptObject jsObj)

  - ### changeAutoChildDefaults

    public static void changeAutoChildDefaults(String autoChildName, Canvas defaults)
    Changes the defaults for Canvas AutoChildren named `autoChildName`.
    Parameters:
      `autoChildName` - name of an AutoChild to customize the defaults for.
      `defaults` - Canvas defaults to apply. These defaults override any existing properties without destroying or wiping out non-overridden properties. For usage tips on this param, see `SGWTProperties`.
    See Also:
      - `AutoChildUsage`

  - ### changeAutoChildDefaults

    public static void changeAutoChildDefaults(String autoChildName, FormItem defaults)
    Changes the defaults for FormItem AutoChildren named `autoChildName`.
    Parameters:
      `autoChildName` - name of an AutoChild to customize the defaults for.
      `defaults` - FormItem defaults to apply. These defaults override any existing properties without destroying or wiping out non-overridden properties. For usage tips on this param, see `SGWTProperties`.
    See Also:
      - `AutoChildUsage`

  - ### create

    protected JavaScriptObject create()
    Overrides:
      `create` in class `Layout`

  - ### getControlBar

    public VLayout getControlBar() throws IllegalStateException
    VLayout autoChild holding the `selectAllButton`, `selectButton`, `deselectButton` and `deselectAllButton`

    This component is an AutoChild named "controlBar". For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

    Returns:
      Current controlBar value. Default value is null
    Throws:
      `IllegalStateException` - if this widget has not yet been rendered.

  - ### setData

    public Shuttle setData(Record... data) throws IllegalStateException
    List of options for this shuttle.

    Note that a shuttle must have either a data object or a dataSource specified

    Parameters:
      `data` - New data value. Default value is null
    Returns:
      `Shuttle` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### setDataSource

    public Shuttle setDataSource(DataSource dataSource) throws IllegalStateException
    DataSource for this shuttle's data set. The list of options will be fetched from this dataSource unless an explicit `data` object was also provided.

    Note that a shuttle must have either a dataSource or data object.

    Parameters:
      `dataSource` - New dataSource value. Default value is null
    Returns:
      `Shuttle` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getDataSource

    public DataSource getDataSource()
    DataSource for this shuttle's data set. The list of options will be fetched from this dataSource unless an explicit `data` object was also provided.

    Note that a shuttle must have either a dataSource or data object.

    Returns:
      Current dataSource value. Default value is null

  - ### getDeselectAllButton

    public ImgButton getDeselectAllButton() throws IllegalStateException
    ImgButton for deselecting the full set of selected data in the shuttle.

    This component is an AutoChild named "deselectAllButton". For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

    Returns:
      Current deselectAllButton value. Default value is null
    Throws:
      `IllegalStateException` - if this widget has not yet been rendered.

  - ### setDeselectAllButtonHeight

    public Shuttle setDeselectAllButtonHeight(Integer deselectAllButtonHeight) throws IllegalStateException
    Height for the `deselectAllButton`
    Parameters:
      `deselectAllButtonHeight` - New deselectAllButtonHeight value. Default value is 22
    Returns:
      `Shuttle` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getDeselectAllButtonHeight

    public Integer getDeselectAllButtonHeight()
    Height for the `deselectAllButton`
    Returns:
      Current deselectAllButtonHeight value. Default value is 22

  - ### setDeselectAllButtonIcon

    public Shuttle setDeselectAllButtonIcon(String deselectAllButtonIcon) throws IllegalStateException
    Icon for the `deselectAllButton`
    Parameters:
      `deselectAllButtonIcon` - New deselectAllButtonIcon value. Default value is "[SKINIMG]TransferIcons/left_all.png"
    Returns:
      `Shuttle` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created
    See Also:
      - `SCImgURL`

  - ### getDeselectAllButtonIcon

    public String getDeselectAllButtonIcon()
    Icon for the `deselectAllButton`
    Returns:
      Current deselectAllButtonIcon value. Default value is "[SKINIMG]TransferIcons/left_all.png"
    See Also:
      - `SCImgURL`

  - ### setDeselectAllButtonWidth

    public Shuttle setDeselectAllButtonWidth(Integer deselectAllButtonWidth) throws IllegalStateException
    Width for the `deselectAllButton`
    Parameters:
      `deselectAllButtonWidth` - New deselectAllButtonWidth value. Default value is 24
    Returns:
      `Shuttle` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getDeselectAllButtonWidth

    public Integer getDeselectAllButtonWidth()
    Width for the `deselectAllButton`
    Returns:
      Current deselectAllButtonWidth value. Default value is 24

  - ### getDeselectButton

    public ImgButton getDeselectButton() throws IllegalStateException
    ImgButton for deselecting a single record

    This component is an AutoChild named "deselectButton". For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

    Returns:
      Current deselectButton value. Default value is null
    Throws:
      `IllegalStateException` - if this widget has not yet been rendered.

  - ### setDeselectButtonHeight

    public Shuttle setDeselectButtonHeight(Integer deselectButtonHeight) throws IllegalStateException
    Height for the `deselectButton`
    Parameters:
      `deselectButtonHeight` - New deselectButtonHeight value. Default value is 22
    Returns:
      `Shuttle` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getDeselectButtonHeight

    public Integer getDeselectButtonHeight()
    Height for the `deselectButton`
    Returns:
      Current deselectButtonHeight value. Default value is 22

  - ### setDeselectButtonIcon

    public Shuttle setDeselectButtonIcon(String deselectButtonIcon) throws IllegalStateException
    Icon for the `deselectButton`
    Parameters:
      `deselectButtonIcon` - New deselectButtonIcon value. Default value is "[SKINIMG]TransferIcons/left.png"
    Returns:
      `Shuttle` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created
    See Also:
      - `SCImgURL`

  - ### getDeselectButtonIcon

    public String getDeselectButtonIcon()
    Icon for the `deselectButton`
    Returns:
      Current deselectButtonIcon value. Default value is "[SKINIMG]TransferIcons/left.png"
    See Also:
      - `SCImgURL`

  - ### setDeselectButtonWidth

    public Shuttle setDeselectButtonWidth(Integer deselectButtonWidth) throws IllegalStateException
    Width for the `deselectButton`
    Parameters:
      `deselectButtonWidth` - New deselectButtonWidth value. Default value is 24
    Returns:
      `Shuttle` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getDeselectButtonWidth

    public Integer getDeselectButtonWidth()
    Width for the `deselectButton`
    Returns:
      Current deselectButtonWidth value. Default value is 24

  - ### setFetchOperation

    public Shuttle setFetchOperation(String fetchOperation) throws IllegalStateException
    `OperationId` for fetching records from the shuttle's `DataSource`.
    Parameters:
      `fetchOperation` - New fetchOperation value. Default value is null
    Returns:
      `Shuttle` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getFetchOperation

    public String getFetchOperation()
    `OperationId` for fetching records from the shuttle's `DataSource`.
    Returns:
      Current fetchOperation value. Default value is null

  - ### setFields

    public Shuttle setFields(ListGridField... fields) throws IllegalStateException
    Fields for the `sourceGrid` and `targetGrid`.

    As with other databound components, if fields are not explicitly specified, they will be derived from the `dataSource` as described `here`

    Parameters:
      `fields` - New fields value. Default value is null
    Returns:
      `Shuttle` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getFields

    public ListGridField[] getFields()
    Fields for the `sourceGrid` and `targetGrid`.

    As with other databound components, if fields are not explicitly specified, they will be derived from the `dataSource` as described `here`

    Returns:
      Current fields value. Default value is null

  - ### setFilterContext

    public Shuttle setFilterContext(DSRequest filterContext) throws IllegalStateException
    DSRequest configuration for retrieving records from this shuttle's dataSource.
    Parameters:
      `filterContext` - New filterContext value. Default value is null
    Returns:
      `Shuttle` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getFilterContext

    public DSRequest getFilterContext()
    DSRequest configuration for retrieving records from this shuttle's dataSource.
    Returns:
      Current filterContext value. Default value is null

  - ### setImplicitCriteria

    public Shuttle setImplicitCriteria(Criteria implicitCriteria)
    Implicit criteria for retrieving records from this shuttle's dataSource.

    These criteria may be combined with `"inSet"` or `"notInSet"` sub criteria for the `valueField` in order to populate the set of unselected records in the `sourceGrid`. They are `ListGrid.implicitCriteria` meaning that any user-entered `filter criteria` will be overlayed on top of these criteria.
    If this method is called after the component has been drawn/initialized: Update the `implicitCriteria` for the shuttle.

    Parameters:
      `implicitCriteria` - new implicitCriteria. Default value is null
    Returns:
      `Shuttle` instance, for chaining setter calls

  - ### getImplicitCriteria

    public Criteria getImplicitCriteria()
    Implicit criteria for retrieving records from this shuttle's dataSource.

    These criteria may be combined with `"inSet"` or `"notInSet"` sub criteria for the `valueField` in order to populate the set of unselected records in the `sourceGrid`. They are `ListGrid.implicitCriteria` meaning that any user-entered `filter criteria` will be overlayed on top of these criteria.

    Returns:
      Current implicitCriteria value. Default value is null

  - ### setIncompleteDataWarning

    public Shuttle setIncompleteDataWarning(String incompleteDataWarning) throws IllegalStateException
    Warning to display when the user attempts to `select all` records from a `partially loaded` data set.
    Parameters:
      `incompleteDataWarning` - New incompleteDataWarning value. Default value is "Unable to select all - the data set does not have all matching records loaded from the dataSource."
    Returns:
      `Shuttle` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getIncompleteDataWarning

    public String getIncompleteDataWarning()
    Warning to display when the user attempts to `select all` records from a `partially loaded` data set.
    Returns:
      Current incompleteDataWarning value. Default value is "Unable to select all - the data set does not have all matching records loaded from the dataSource."

  - ### setInitialSort

    public Shuttle setInitialSort(SortSpecifier... initialSort) throws IllegalStateException
    `Initial sort specifiers` for this item's list of options. Will be applied to `sourceGrid` and `targetGrid`. To specify initial sort for each grid separately, these properties may be set per grid using the standard `autoChild pattern`.
    Parameters:
      `initialSort` - New initialSort value. Default value is null
    Returns:
      `Shuttle` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getInitialSort

    public SortSpecifier[] getInitialSort()
    `Initial sort specifiers` for this item's list of options. Will be applied to `sourceGrid` and `targetGrid`. To specify initial sort for each grid separately, these properties may be set per grid using the standard `autoChild pattern`.
    Returns:
      Current initialSort value. Default value is null

  - ### setLoadingPlaceholderAttribute

    public Shuttle setLoadingPlaceholderAttribute(String loadingPlaceholderAttribute) throws IllegalStateException
    This attribute will be set to true for any loading placeholder records returned by `getSelectedRecords()`

    Note : This is an advanced setting

    Parameters:
      `loadingPlaceholderAttribute` - New loadingPlaceholderAttribute value. Default value is "_isLoadingPlaceholder"
    Returns:
      `Shuttle` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getLoadingPlaceholderAttribute

    public String getLoadingPlaceholderAttribute()
    This attribute will be set to true for any loading placeholder records returned by `getSelectedRecords()`
    Returns:
      Current loadingPlaceholderAttribute value. Default value is "_isLoadingPlaceholder"

  - ### getSelectAllButton

    public ImgButton getSelectAllButton() throws IllegalStateException
    ImgButton for selecting the full set of data in the shuttle.

    This component is an AutoChild named "selectAllButton". For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

    Returns:
      Current selectAllButton value. Default value is null
    Throws:
      `IllegalStateException` - if this widget has not yet been rendered.

  - ### setSelectAllButtonHeight

    public Shuttle setSelectAllButtonHeight(Integer selectAllButtonHeight) throws IllegalStateException
    Height for the `selectAllButton`
    Parameters:
      `selectAllButtonHeight` - New selectAllButtonHeight value. Default value is 22
    Returns:
      `Shuttle` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getSelectAllButtonHeight

    public Integer getSelectAllButtonHeight()
    Height for the `selectAllButton`
    Returns:
      Current selectAllButtonHeight value. Default value is 22

  - ### setSelectAllButtonIcon

    public Shuttle setSelectAllButtonIcon(String selectAllButtonIcon) throws IllegalStateException
    Icon for the `selectAllButton`
    Parameters:
      `selectAllButtonIcon` - New selectAllButtonIcon value. Default value is "[SKINIMG]TransferIcons/right_all.png"
    Returns:
      `Shuttle` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created
    See Also:
      - `SCImgURL`

  - ### getSelectAllButtonIcon

    public String getSelectAllButtonIcon()
    Icon for the `selectAllButton`
    Returns:
      Current selectAllButtonIcon value. Default value is "[SKINIMG]TransferIcons/right_all.png"
    See Also:
      - `SCImgURL`

  - ### setSelectAllButtonWidth

    public Shuttle setSelectAllButtonWidth(Integer selectAllButtonWidth) throws IllegalStateException
    Width for the `selectAllButton`
    Parameters:
      `selectAllButtonWidth` - New selectAllButtonWidth value. Default value is 24
    Returns:
      `Shuttle` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getSelectAllButtonWidth

    public Integer getSelectAllButtonWidth()
    Width for the `selectAllButton`
    Returns:
      Current selectAllButtonWidth value. Default value is 24

  - ### getSelectButton

    public ImgButton getSelectButton() throws IllegalStateException
    ImgButton for selecting a single record

    This component is an AutoChild named "selectButton". For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

    Returns:
      Current selectButton value. Default value is null
    Throws:
      `IllegalStateException` - if this widget has not yet been rendered.

  - ### setSelectButtonHeight

    public Shuttle setSelectButtonHeight(Integer selectButtonHeight) throws IllegalStateException
    Height for the `selectButton`
    Parameters:
      `selectButtonHeight` - New selectButtonHeight value. Default value is 22
    Returns:
      `Shuttle` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getSelectButtonHeight

    public Integer getSelectButtonHeight()
    Height for the `selectButton`
    Returns:
      Current selectButtonHeight value. Default value is 22

  - ### setSelectButtonIcon

    public Shuttle setSelectButtonIcon(String selectButtonIcon) throws IllegalStateException
    Icon for the `selectButton`
    Parameters:
      `selectButtonIcon` - New selectButtonIcon value. Default value is "[SKINIMG]TransferIcons/right.png"
    Returns:
      `Shuttle` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created
    See Also:
      - `SCImgURL`

  - ### getSelectButtonIcon

    public String getSelectButtonIcon()
    Icon for the `selectButton`
    Returns:
      Current selectButtonIcon value. Default value is "[SKINIMG]TransferIcons/right.png"
    See Also:
      - `SCImgURL`

  - ### setSelectButtonWidth

    public Shuttle setSelectButtonWidth(Integer selectButtonWidth) throws IllegalStateException
    Width for the `selectButton`
    Parameters:
      `selectButtonWidth` - New selectButtonWidth value. Default value is 24
    Returns:
      `Shuttle` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getSelectButtonWidth

    public Integer getSelectButtonWidth()
    Width for the `selectButton`
    Returns:
      Current selectButtonWidth value. Default value is 24

  - ### setSelectedRecords

    public Shuttle setSelectedRecords(ListGridRecord selectedRecords) throws IllegalStateException
    A shuttle may be initialized with a set of selected records via `setSelectedRecords()` before the shuttle has been created.

    See also `selectedValues` for initializing selection based on record values.

    To update the selection at runtime use `selectRecords()` and `deselectRecords()`.

    Parameters:
      `selectedRecords` - New selectedRecords value. Default value is null
    Returns:
      `Shuttle` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getSelectedRecords

    public ListGridRecord getSelectedRecords()
    A shuttle may be initialized with a set of selected records via `setSelectedRecords()` before the shuttle has been created.

    See also `selectedValues` for initializing selection based on record values.

    To update the selection at runtime use `selectRecords()` and `deselectRecords()`.

    Returns:
      Returns the current set of selected records.

      Note that if a user called `setSelectedByValue()` for a record that was not loaded in the source list, we may not yet have a selected record for that value. See `valuesFetchInProgress()`.

      In this case no record will be returned by this method for that record by default. The `includeLoadingPlaceholders` parameter will cause this method to also return placeholder record objects for these unloaded records, which have two properties specified - the `valueField` value `_isLoadingPlaceholder:true`. Default value is null

  - ### setSelectedValues

    public Shuttle setSelectedValues(String... selectedValues) throws IllegalStateException
    Initial selected values for the shuttle.

    If specified, the shuttle will be initialized with records with matching `valueField` being selected.

    See also `selectedRecords` for initializing selection with specific records. If both properties are specified, `selectedValues` will have no effect

    To update the selection by value at runtime use `setSelectedByValue()`

    Parameters:
      `selectedValues` - New selectedValues value. Default value is null
    Returns:
      `Shuttle` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getSelectedValues

    public String[] getSelectedValues()
    Initial selected values for the shuttle.

    If specified, the shuttle will be initialized with records with matching `valueField` being selected.

    See also `selectedRecords` for initializing selection with specific records. If both properties are specified, `selectedValues` will have no effect

    To update the selection by value at runtime use `setSelectedByValue()`

    Returns:
      Returns the `valueField` value from the current set of selected records.

      Note that if a user called `setSelectedByValue()` for a record that was not loaded in the source list, we may not yet have a selected record for that value. See `valuesFetchInProgress()`.

      The `includeUnloadedValues` parameter can be used to return values for these unloaded records. Default value is null

  - ### setSelectedValues

    public Shuttle setSelectedValues(int... selectedValues) throws IllegalStateException
    Initial selected values for the shuttle.

    If specified, the shuttle will be initialized with records with matching `valueField` being selected.

    See also `selectedRecords` for initializing selection with specific records. If both properties are specified, `selectedValues` will have no effect

    To update the selection by value at runtime use `setSelectedByValue()`

    Parameters:
      `selectedValues` - New selectedValues value. Default value is null
    Returns:
      `Shuttle` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getSelectedValuesAsIntArray

    public int[] getSelectedValuesAsIntArray()
    Initial selected values for the shuttle.

    If specified, the shuttle will be initialized with records with matching `valueField` being selected.

    See also `selectedRecords` for initializing selection with specific records. If both properties are specified, `selectedValues` will have no effect

    To update the selection by value at runtime use `setSelectedByValue()`

    Returns:
      Returns the `valueField` value from the current set of selected records.

      Note that if a user called `setSelectedByValue()` for a record that was not loaded in the source list, we may not yet have a selected record for that value. See `valuesFetchInProgress()`.

      The `includeUnloadedValues` parameter can be used to return values for these unloaded records. Default value is null

  - ### setSortDirection

    public Shuttle setSortDirection(SortDirection sortDirection) throws IllegalStateException
    `Sort direction` for this item's list of options. Will be applied to `sourceGrid` and `targetGrid`. To specify initial sort for each grid separately, these properties may be set per grid using the standard `autoChild pattern`.
    Parameters:
      `sortDirection` - New sortDirection value. Default value is null
    Returns:
      `Shuttle` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getSortDirection

    public SortDirection getSortDirection()
    `Sort direction` for this item's list of options. Will be applied to `sourceGrid` and `targetGrid`. To specify initial sort for each grid separately, these properties may be set per grid using the standard `autoChild pattern`.
    Returns:
      Current sortDirection value. Default value is null

  - ### setSortField

    public Shuttle setSortField(String sortField) throws IllegalStateException
    `Sort field` for this item's list of options. Will be applied to `sourceGrid` and `targetGrid`. To specify initial sort for each grid separately, these properties may be set per grid using the standard `autoChild pattern`.
    Parameters:
      `sortField` - New sortField value. Default value is null
    Returns:
      `Shuttle` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getSortField

    public String getSortField()
    `Sort field` for this item's list of options. Will be applied to `sourceGrid` and `targetGrid`. To specify initial sort for each grid separately, these properties may be set per grid using the standard `autoChild pattern`.
    Returns:
      Current sortField value. Default value is null

  - ### setSortField

    public Shuttle setSortField(String... sortField) throws IllegalStateException
    `Sort field` for this item's list of options. Will be applied to `sourceGrid` and `targetGrid`. To specify initial sort for each grid separately, these properties may be set per grid using the standard `autoChild pattern`.
    Parameters:
      `sortField` - New sortField value. Default value is null
    Returns:
      `Shuttle` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getSortFieldAsStringArray

    public String[] getSortFieldAsStringArray()
    `Sort field` for this item's list of options. Will be applied to `sourceGrid` and `targetGrid`. To specify initial sort for each grid separately, these properties may be set per grid using the standard `autoChild pattern`.
    Returns:
      Current sortField value. Default value is null

  - ### setSortField

    public Shuttle setSortField(Integer sortField) throws IllegalStateException
    `Sort field` for this item's list of options. Will be applied to `sourceGrid` and `targetGrid`. To specify initial sort for each grid separately, these properties may be set per grid using the standard `autoChild pattern`.
    Parameters:
      `sortField` - New sortField value. Default value is null
    Returns:
      `Shuttle` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getSortFieldAsInt

    public Integer getSortFieldAsInt()
    `Sort field` for this item's list of options. Will be applied to `sourceGrid` and `targetGrid`. To specify initial sort for each grid separately, these properties may be set per grid using the standard `autoChild pattern`.
    Returns:
      Current sortField value. Default value is null

  - ### getSourceGrid

    public ListGrid getSourceGrid() throws IllegalStateException
    List grid containing the (unselected) set of records. The user may select items by dragging them from this grid to the `targetGrid`.

    This component is an AutoChild named "sourceGrid". For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

    Returns:
      Current sourceGrid value. Default value is null
    Throws:
      `IllegalStateException` - if this widget has not yet been rendered.

  - ### setSourceGridTitle

    public Shuttle setSourceGridTitle(String sourceGridTitle) throws IllegalStateException
    Title for the source grid, shown as a `Canvas.groupTitle`
    Parameters:
      `sourceGridTitle` - New sourceGridTitle value. Default value is "Unselected Values"
    Returns:
      `Shuttle` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getSourceGridTitle

    public String getSourceGridTitle()
    Title for the source grid, shown as a `Canvas.groupTitle`
    Returns:
      Current sourceGridTitle value. Default value is "Unselected Values"

  - ### getTargetGrid

    public ListGrid getTargetGrid() throws IllegalStateException
    List grid containing the selected set of records. The user may unselect items by dragging them from this grid to the `sourceGrid`.

    This component is an AutoChild named "targetGrid". For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

    Returns:
      Current targetGrid value. Default value is null
    Throws:
      `IllegalStateException` - if this widget has not yet been rendered.

  - ### setTargetGridTitle

    public Shuttle setTargetGridTitle(String targetGridTitle) throws IllegalStateException
    Title for the target grid, shown as a `Canvas.groupTitle`
    Parameters:
      `targetGridTitle` - New targetGridTitle value. Default value is "Selected Values"
    Returns:
      `Shuttle` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getTargetGridTitle

    public String getTargetGridTitle()
    Title for the target grid, shown as a `Canvas.groupTitle`
    Returns:
      Current targetGridTitle value. Default value is "Selected Values"

  - ### setTextMatchStyle

    public Shuttle setTextMatchStyle(TextMatchStyle textMatchStyle) throws IllegalStateException
    TextMatchStyle for retrieving records from this shuttle's dataSource.
    Parameters:
      `textMatchStyle` - New textMatchStyle value. Default value is "substring"
    Returns:
      `Shuttle` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getTextMatchStyle

    public TextMatchStyle getTextMatchStyle()
    TextMatchStyle for retrieving records from this shuttle's dataSource.
    Returns:
      Current textMatchStyle value. Default value is "substring"

  - ### setValueField

    public Shuttle setValueField(String valueField) throws IllegalStateException
    This field is expected to be unique for records within the shuttle's data set. If not explicitly specified the `dataSource.primaryKey` will be used.

    May be used to `select records by value` and to retrieve the current `selected values`.

    Parameters:
      `valueField` - New valueField value. Default value is null
    Returns:
      `Shuttle` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getValueField

    public String getValueField()
    This field is expected to be unique for records within the shuttle's data set. If not explicitly specified the `dataSource.primaryKey` will be used.

    May be used to `select records by value` and to retrieve the current `selected values`.

    Returns:
      Current valueField value. Default value is null

  - ### clearSelection

    public void clearSelection()
    Deselect all currently selected records

  - ### clearSelection

    public void clearSelection(boolean fireSelectionChanged)
    Deselect all currently selected records
    Parameters:
      `fireSelectionChanged` - Fire the `selectionUpdated()` notification?

  - ### deselectRecords

    public void deselectRecords(ListGridRecord[] records)
    Programmatically deselect a set of records that are currently selected and displayed in the target grid.
    Parameters:
      `records` - Records to deselect

  - ### deselectRecords

    public void deselectRecords(ListGridRecord[] records, boolean fireSelectionChanged)
    Programmatically deselect a set of records that are currently selected and displayed in the target grid.
    Parameters:
      `records` - Records to deselect
      `fireSelectionChanged` - Fire the `selectionUpdated()` notification?

  - ### getValueFieldName

    public String getValueFieldName()
    Returns the `valueField` for this shuttle
    Returns:
      value field name

  - ### selectionUpdated

    public void selectionUpdated()
    Notification method fired when records are selected or unselected in this shuttle.

    Use `getSelectedRecords()` or `getSelectedValues()` to retrieve the current selection.

  - ### selectRecords

    public void selectRecords(ListGridRecord[] records)
    Programmatically select a set of records from this shuttle's dataSource. The specified records will be added to any existing selection.
    Parameters:
      `records` - Records to select

  - ### selectRecords

    public void selectRecords(ListGridRecord[] records, boolean fireSelectionChanged)
    Programmatically select a set of records from this shuttle's dataSource. The specified records will be added to any existing selection.
    Parameters:
      `records` - Records to select
      `fireSelectionChanged` - Fire the `selectionUpdated()` notification?

  - ### setSelectedByValue

    public void setSelectedByValue(String[] value, Boolean selected)
    Method to add or remove records from the current selection where the `valueField` matches the values passed in.

    If the source listGrid does not have a `complete data set` and does not contain an entry for any of the requested values, a separate fetch request will be issued against our `DataSource` to pick up the records for the specified value(s). The `valuesFetchInProgress()` and `valuesFetchComplete()` methods provide information about this fetch.

    Parameters:
      `value` - Array of values to select
      `selected` - New selected state for the records

  - ### setSelectedByValue

    public void setSelectedByValue(int[] value, Boolean selected)
    Method to add or remove records from the current selection where the `valueField` matches the values passed in.

    If the source listGrid does not have a `complete data set` and does not contain an entry for any of the requested values, a separate fetch request will be issued against our `DataSource` to pick up the records for the specified value(s). The `valuesFetchInProgress()` and `valuesFetchComplete()` methods provide information about this fetch.

    Parameters:
      `value` - Array of values to select
      `selected` - New selected state for the records

  - ### valuesFetchComplete

    public boolean valuesFetchComplete()
    Notification method fired when a fetch to retrieve records for an array of values passed to `setSelectedByValue()` is complete.

    Note that if no associated record for the specified value was found in the dataSource, this method will still fire.

    Returns:
      true if there is an outstanding values fetch

  - ### valuesFetchInProgress

    public boolean valuesFetchInProgress()
    Returns true if this shuttle is currently fetching record(s) associated with values passed to `setSelectedByValue()`

    If no explicit `value` parameter was passed, this method will return true if this shuttle has any outstanding values fetches.

    Returns:
      true if there is an outstanding values fetch

  - ### valuesFetchInProgress

    public boolean valuesFetchInProgress(Object value)
    Returns true if this shuttle is currently fetching record(s) associated with values passed to `setSelectedByValue()`

    If no explicit `value` parameter was passed, this method will return true if this shuttle has any outstanding values fetches.

    Parameters:
      `value` - if passed, this method will return true only if there is an outstanding fetch to retrieve the associated record for this specified value
    Returns:
      true if there is an outstanding values fetch

  - ### setDefaultProperties

    public static void setDefaultProperties(Shuttle shuttleProperties)
    Class level method to set the default properties of this class. If set, then all existing and subsequently created instances of this class will automatically have default properties corresponding to the properties set on the SmartGWT class instance passed to this function before its underlying SmartClient JS object was created. This is a powerful feature that eliminates the need for users to create a separate hierarchy of subclasses that only alter the default properties of this class. Can also be used for skinning / styling purposes.

    Note: This method is intended for setting default attributes only and will affect all instances of the underlying class (including those automatically generated in JavaScript). This method should not be used to apply standard EventHandlers or override methods for a class - use a custom subclass instead. Calling this method after instances have been created can result in undefined behavior, since it bypasses any setters and a class instance may have already examined a particular property and not be expecting any changes through this route.

    Parameters:
      `shuttleProperties` - properties that should be used as new defaults when instances of this class are created
    See Also:
      - `SGWTProperties`

  - ### setLogicalStructure

    public LogicalStructureObject setLogicalStructure(ShuttleLogicalStructure s)
    Setter implementing the `LogicalStructure` interface, which supports Eclipse's logical structure debugging facility.

  - ### getLogicalStructure

    public LogicalStructureObject getLogicalStructure()
    Getter implementing the `LogicalStructure` interface, which supports Eclipse's logical structure debugging facility.
    Specified by:
      `getLogicalStructure` in interface `LogicalStructure`
    Overrides:
      `getLogicalStructure` in class `Layout`